
volatile char ctr; 

volatile unsigned int index_sin = 0; 

volatile unsigned char index_a_sin = 0; 
volatile unsigned char index_b_sin = 0; 

volatile unsigned int temp_16; 
volatile unsigned char temp_8; 

volatile unsigned char temp_a; 
volatile unsigned char temp_b; 

volatile unsigned char pol_a = 1; 
volatile unsigned char pol_b = 1; 

volatile unsigned char index_bc_calc = 1; 

volatile unsigned char  inc_ind = 1;  

volatile unsigned int freq_int = 350; 

volatile unsigned char amp_sin = 0; 

#pragma used+
sfrb PINB=3;
sfrb DDRB=4;
sfrb PORTB=5;
sfrb PINC=6;
sfrb DDRC=7;
sfrb PORTC=8;
sfrb PIND=9;
sfrb DDRD=0xa;
sfrb PORTD=0xb;
sfrb TIFR0=0x15;
sfrb TIFR1=0x16;
sfrb TIFR2=0x17;
sfrb PCIFR=0x1b;
sfrb EIFR=0x1c;
sfrb EIMSK=0x1d;
sfrb GPIOR0=0x1e;
sfrb EECR=0x1f;
sfrb EEDR=0x20;
sfrb EEARL=0x21;
sfrb EEARH=0x22;
sfrw EEAR=0x21;   
sfrb GTCCR=0x23;
sfrb TCCR0A=0x24;
sfrb TCCR0B=0x25;
sfrb TCNT0=0x26;
sfrb OCR0A=0x27;
sfrb OCR0B=0x28;
sfrb GPIOR1=0x2a;
sfrb GPIOR2=0x2b;
sfrb SPCR=0x2c;
sfrb SPSR=0x2d;
sfrb SPDR=0x2e;
sfrb ACSR=0x30;
sfrb SMCR=0x33;
sfrb MCUSR=0x34;
sfrb MCUCR=0x35;
sfrb SPMCSR=0x37;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
	.EQU __sm_adc_noise_red=0x02
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C
	.SET power_ctrl_reg=smcr
	#endif
#endasm

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

typedef char *va_list;

#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);
int printf(char flash *fmtstr,...);
int sprintf(char *str, char flash *fmtstr,...);
int vprintf(char flash * fmtstr, va_list argptr);
int vsprintf(char *str, char flash * fmtstr, va_list argptr);

char *gets(char *str,unsigned int len);
int snprintf(char *str, unsigned int size, char flash *fmtstr,...);
int vsnprintf(char *str, unsigned int size, char flash * fmtstr, va_list argptr);

int scanf(char flash *fmtstr,...);
int sscanf(char *str, char flash *fmtstr,...);

#pragma used-

#pragma library stdio.lib

flash unsigned char sinus[128]=
{
0,   3,   6,   9,   12,  16,  19,  22,  25,  28,  31,  34,  37,  40,  43,  46,  
49,  51,  54,  57,  60,  63,  65,  68,  71,  73,  76,  78,  81,  83,  85,  88,  
90,  92,  94,  96,  98,  100, 102, 104, 106, 107, 109, 111, 112, 113, 115, 116, 
117, 118, 120, 121, 122, 122, 123, 124, 125, 125, 126, 126, 126, 127, 127, 127, 
127, 127, 127, 127, 126, 126, 126, 125, 125, 124, 123, 122, 122, 121, 120, 118, 
117, 116, 115, 113, 112, 111, 109, 107, 106, 104, 102, 100, 98,  96,  94,  92,  
90,  88,  85,  83,  81,  78,  76,  73,  71,  68,  65,  63,  60,  57,  54,  51,  
49,  46,  43,  40,  37,  34,  31,  28,  25,  22,  19,  16,  12,  9,   6,   3  
};

interrupt [12] void timer1_compa_isr(void)
{

PORTB^=1; 

if (index_a_sin > 127){ 
index_a_sin -= 128;

index_bc_calc = 0; 

if (pol_a){ 
pol_a = 0; pol_b = 0; PORTB ^=(1<< 1); PORTB ^=(1<< 2);
index_b_sin = index_a_sin + 127;  

}
else{
pol_a = 1; pol_b = 1;
index_b_sin = index_a_sin + 127;   

} 
}        

if (index_bc_calc) {  

if (index_b_sin > 127){ 
index_b_sin -= 128;  

if (pol_b){ 
pol_b = 0; PORTB ^=(1<< 3); PORTB ^=(1<< 4);
}
else{
pol_b = 1; 
} 
}

}

temp_8 = (((unsigned int)amp_sin * (unsigned int)sinus[index_a_sin])) >> 8;

if (pol_a){ 
temp_a = temp_8 + 127; 
}
else{   
temp_a = 127 - temp_8;
} 

temp_8 = (((unsigned int)amp_sin * (unsigned int)sinus[index_b_sin])) >> 8;

if (pol_b){ 
temp_b = temp_8 + 127; 
}
else{   
temp_b = 127 - temp_8;
} 

OCR0A = temp_a;  
OCR0B = temp_b;  

index_a_sin += inc_ind;  
index_b_sin += inc_ind;  

index_bc_calc = 1; 
temp_8 = 0; 
}                   

interrupt [17] void timer0_ovf_isr(void)
{
}

interrupt [15] void timer0_compa_isr(void)
{
}

interrupt [16] void timer0_compb_isr(void)
{
}

void main(void)
{

DDRB=( (1<<1) | (1<<2) | (1<<3) | (1<<4));

PORTB=(1<<1) | (0<<2) | (1<<3) | (0<<4);

#pragma optsize- 
(*(unsigned char *) 0x61)=0x80;  
(*(unsigned char *) 0x61)=0x00;

DDRB.0 = 1; 

TCCR0A=0xA1;
TCCR0B=0x01;
TCNT0=0x00;

OCR0A=127; 
OCR0B=127; 

DDRD|=(1<<5)|(1<<6); 

(*(unsigned char *) 0x81) = 0x00; 

(*(unsigned char *) 0x89) = (unsigned char)(freq_int >> 8);
(*(unsigned char *) 0x88) = (unsigned char)freq_int;

(*(unsigned char *) 0x80) = 0x00;
(*(unsigned char *) 0x81) = 0x0A; 

(*(unsigned char *) 0x69)=0x00;
EIMSK=0x00;
(*(unsigned char *) 0x68)=0x00;

(*(unsigned char *) 0x6e)=0x07;

(*(unsigned char *) 0x6f)=0x02;

(*(unsigned char *) 0x70)=0x00;

#asm("sei")

while (1)
{

amp_sin = 250; 

};
}

